SystemOrganization addCategory: #BinarySearch!

Object subclass: #BinarySearcher
	instanceVariableNames: 'eq e left right root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
accuracy

	^e! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
accuracy: aNumber

	e := aNumber abs! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equalsZero: aNumber

	^aNumber abs <= self accuracy! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equation

	^eq! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equation: aBlock

	"equation must be monotone function"
	self left equation: aBlock.
	self right equation: aBlock.
	eq := aBlock! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
jumpToMiddleOfLeftAndRight
	
	| new |
	
	new := self newPointOnFunction.

	new x: (left x+right x)/2.
	(new ySignSameWith: left) ifFalse: [ right := new ].
	(new ySignSameWith: right) ifFalse: [ left := new ]! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
jumpToOutsideOfLeftAndRight
	
	| new bigger smaller |
	
	new := self newPointOnFunction.
		
	bigger := left biggerYAbsolute: right.
	smaller := left smallerYAbsolute: right.
	
	new x: 2*smaller x - bigger x.
	smaller x: bigger x.
	bigger x: new x! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
left

	left isNil ifTrue: [ left := PointOnFunction new ].
	^left! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
left: aNumber

	^self left x: aNumber! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
loopCondition

	(self equalsZero: left y) ifTrue: [ root := left ].
	(self equalsZero: right y) ifTrue: [ root := right ].
	(self left x equals: self right x) ifTrue: [ root := left ].
	^root isNil! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
newPointOnFunction

	^PointOnFunction new
		equation: self equation;
		yourself
! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
printLeftRightOnTranscript

	Transcript print: self left x; space; space; print: self right y; cr; flush! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
pseudoSolution

	^(self left x + self right x) / 2! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
range: aRange 

	self left: aRange start.
	self right: aRange stop! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
reset

	root isNil ifFalse: [
	self left x: self left x - Float epsilon.
	self right x: self right x + Float epsilon].
	root := nil! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
right

	right isNil ifTrue: [ right := PointOnFunction new ].
	^right
! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
right: aNumber

	^self right x: aNumber! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
root

	^root! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
run

	[self step] whileTrue! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
solution

	self solve.
	^self root x! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
solve

	self reset.
	self run.
	^root x
! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
step

	^self loopCondition ifTrue: [self stepOperation. true] ifFalse: [false]! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
stepOperation

	(left ySignSameWith: right)
		ifTrue: [ self jumpToOutsideOfLeftAndRight ]
		ifFalse: [ self jumpToMiddleOfLeftAndRight ]
! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
value: aNumber

	^self equation value: aNumber! !

!BinarySearcher methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
widenBy: aNumber

	self left x: self left x - aNumber.
	self right x: self right x + aNumber! !

Object subclass: #PointOnFunction
	instanceVariableNames: 'eq x y'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
biggerYAbsolute: aPointOnFunction 

	^self y abs > aPointOnFunction y abs
		ifTrue: [ self ]
		ifFalse: [ aPointOnFunction  ]! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equation

	^eq! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
equation: aBlock

	eq := aBlock! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: $(.
	aStream print: self x.
	aStream nextPut: $@.
	aStream print: self y.
	aStream nextPut: $)! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
smallerYAbsolute: aPointOnFunction 

	^self y abs <= aPointOnFunction y abs
		ifTrue: [ self ]
		ifFalse: [ aPointOnFunction  ]! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
x

	^x! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
x: aNumber

	y := nil.
	x := aNumber! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
y

	(y isNil and: [ self equation notNil ]) ifTrue: [ y := self equation value: self x ].
	^y! !

!PointOnFunction methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
ySignSameWith: aPointOnFunction 

	^self y * aPointOnFunction y > 0! !

TestCase subclass: #BinarySearcherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'BinarySearch'!

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
test1

	|b|
	(b := BinarySearcher new)
		left: 1.0;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.
	self assertEquals: b solve to: 0

! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
test2

	|b|

	(b := BinarySearcher new)
		left: 0.5;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.
	self assert: (b value: b solve) < b accuracy
! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
testPointOnFunction

	|p|
	p := PointOnFunction new.
	p x: 1.
	self assert: p x = 1.
	p x: 2.
	self assertEquals: p x to: 2.! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
testPointOnFunctionRecalculateY

	|p|
	p := PointOnFunction new.
	p x: 2.
	p equation: [:x| x squared ].
	p x: 3.
	self assertEquals: p y to: 9.
! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
testPointOnFunctionY

	|p|
	p := PointOnFunction new.
	p x: 2.
	p equation: [:x| x squared ].
	self assertEquals: p y to: 4.
! !

!BinarySearcherTest methodsFor: 'as yet unclassified' stamp: 'hjo 3/24/2008 10:27'!
testSteppingEqualsSolve

	|b steppingRoot solveRoot|

	(b := BinarySearcher new)
		left: 0.5;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.

	[b step] whileTrue.
	steppingRoot := b root x.

	(b := BinarySearcher new)
		left: 0.5;
		right: 3.0;
		equation: [:x| x negated raisedTo: 3];
		accuracy: 0.0000000001.

	solveRoot := b solve.

	self assert: steppingRoot = solveRoot
	! !
